/////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>

//lazy -  for zbeos this is big enough 
#define SIZE 2048000 

static int ID1 = 0x1f;
static int ID2 = 0x8b;
static int CM = 0x08;
static int ID_BYTES = 3;

int  main (int argc, char* args[]){

    FILE* fin;
    FILE* fout;
    
    char outfile[50];
    
    int i;
    int numgzips = 0;
    long begin = 2147438647;
    long end = 0;
    int buf[SIZE];
    int finished = 0;
    
    printf("*******************************************\n");
    printf("*\n");
    printf("* dezbeos -  extracts gzip files from zbeos\n");
    printf("*         -  bru::pirge 07-12-2001\n");
    printf("*	      -  thanks to Amino");
    printf("*\n");
    printf("*******************************************\n");
    
    fin = fopen("zbeos", "rb");
    if(!fin){
	printf("Could not read zbeos!\nPlease run in the same directory as zbeos\n");
	exit(1);	
    }    
    
    //read file and extract gzip files
    while(!feof(fin)){
	//is this a gzip file
	if( fgetc(fin) == ID1 &&  fgetc(fin) == ID2 && fgetc(fin) == CM){	 
		    //set begin offset
		    begin = ftell(fin);
		    //count gzip files found
		    numgzips++;
		    printf("Found gzip file %d at offsets: start 0x%x ",numgzips,begin-ID_BYTES);
		    //save gzip we have found////////////////////////////
		    sprintf(outfile,"found%d.gz",numgzips);
		    		    
		    //find end of gzip - eof or another gzip
		    while(!feof(fin)){
			//set end offset
			end = ftell(fin);
			//is next a gzip id?
			if( fgetc(fin) == ID1 &&  fgetc(fin) == ID2 && fgetc(fin) == CM){	 
			    finished = 1;
			    break;
			}
		    }
		    
		    //if its the end of file then set end offset
		    if(finished == 0)
			end = ftell(fin);
		    //reset begin offset to include the two id bytes
		    //and the file pointer
		    begin -= ID_BYTES;
		    fseek(fin,begin,0);
		    
		    printf("end 0x%x\n",end);
		    
		    //open out file
		    fout = fopen(outfile,"wb");
		    if(!fout){
			printf("could not open %s\n",outfile);
			exit(1);	
		    }
		    //write out the rest 
    		    fread(buf,sizeof(int),end-begin,fin);
		    fwrite(buf,sizeof(int),end-begin,fout);	
		    //close new file
		    close(fout);
		    //reset file pointer
		    fseek(fin,end,0);
	}		       
    }
    //close input
    close(fin);    
    printf("Use: 'gzip -N -d found*.gz' to decompress the gzip files.\nFinished\n");
    return 0;
} 
/////////////////////////////////////////////////////////
